package cn.ibizlab.businesscentral.core.base.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.base.domain.Position;
import cn.ibizlab.businesscentral.core.base.filter.PositionSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[Position] 服务对象接口
 */
public interface IPositionService extends IService<Position>{

    boolean create(Position et) ;
    void createBatch(List<Position> list) ;
    boolean update(Position et) ;
    void updateBatch(List<Position> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    Position get(String key) ;
    Position getDraft(Position et) ;
    boolean checkKey(Position et) ;
    boolean save(Position et) ;
    void saveBatch(List<Position> list) ;
    Page<Position> searchDefault(PositionSearchContext context) ;
    List<Position> selectByParentpositionid(String positionid) ;
    void removeByParentpositionid(String positionid) ;
    List<Position> selectByTransactioncurrencyid(String transactioncurrencyid) ;
    void removeByTransactioncurrencyid(String transactioncurrencyid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<Position> getPositionByIds(List<String> ids) ;
    List<Position> getPositionByEntities(List<Position> entities) ;
}


